"""JSON containing file type identifier and list of stock plans"""

# Autogenerated, do not edit.
# Copyright © 2023 FMR LLC
#
# Based on the Open Captable Format schema:
# Copyright © 2022 Open Cap Table Coalition (https://opencaptablecoalition.com) /
# Original File: https://github.com/Open-Cap-Table-Coalition/Open-Cap-Format-
# OCF/tree/v1.0.0/schema/files/StockPlansFile.schema.json

from pyocf.objects.stockplan import StockPlan
from pyocf.primitives.files.file import FileObject
from typing import Literal


class StockPlansFile(FileObject):
    """JSON containing file type identifier and list of stock plans"""

    # List of OCF stock plan objects
    items: list[StockPlan]
    file_type: Literal["OCF_STOCK_PLANS_FILE"] = "OCF_STOCK_PLANS_FILE"
