"""Object describing a stock legend template"""

# Autogenerated, do not edit.
# Copyright © 2023 FMR LLC
#
# Based on the Open Captable Format schema:
# Copyright © 2022 Open Cap Table Coalition (https://opencaptablecoalition.com) /
# Original File: https://github.com/Open-Cap-Table-Coalition/Open-Cap-Format-
# OCF/tree/v1.0.0/schema/objects/StockLegendTemplate.schema.json

from pyocf.primitives.objects.object import Object
from typing import Literal
from typing import Optional


class StockLegendTemplate(Object):
    """Object describing a stock legend template"""

    object_type: Literal["STOCK_LEGEND_TEMPLATE"] = "STOCK_LEGEND_TEMPLATE"
    # Name for the stock legend template
    name: str
    # The full text of the stock legend
    text: str
    # Identifier for the object
    id: str
    # Unstructured text comments related to and stored for the object
    comments: Optional[list[str]]
