"""Abstract object to be extended by all other objects"""

# Autogenerated, do not edit.
# Copyright © 2023 FMR LLC
#
# Based on the Open Captable Format schema:
# Copyright © 2022 Open Cap Table Coalition (https://opencaptablecoalition.com) /
# Original File: https://github.com/Open-Cap-Table-Coalition/Open-Cap-Format-
# OCF/tree/v1.0.0/schema/primitives/objects/Object.schema.json

from pydantic import BaseModel
from pyocf.enums.objecttype import ObjectType
from typing import Optional


class Object(BaseModel):
    """Abstract object to be extended by all other objects"""

    # Identifier for the object
    id: str
    # Unstructured text comments related to and stored for the object
    comments: Optional[list[str]]
    # Object type field
    object_type: ObjectType
