"""Abstract object describing fields common to all cancellation transaction objects"""

# Autogenerated, do not edit.
# Copyright © 2023 FMR LLC
#
# Based on the Open Captable Format schema:
# Copyright © 2022 Open Cap Table Coalition (https://opencaptablecoalition.com) /
# Original File: https://github.com/Open-Cap-Table-Coalition/Open-Cap-Format-OCF/t
# ree/v1.0.0/schema/primitives/objects/transactions/cancellation/Cancellation.sche
# ma.json

from pydantic import BaseModel
from typing import Optional


class Cancellation(BaseModel):
    """Abstract object describing fields common to all cancellation transaction objects"""

    # Identifier for the security that holds the remainder balance (for partial
    # cancellations)
    balance_security_id: Optional[str]
    # Reason for the cancellation
    reason_text: str
