"""Abstract object describing common properties to a reissuance of a security"""

# Autogenerated, do not edit.
# Copyright © 2023 FMR LLC
#
# Based on the Open Captable Format schema:
# Copyright © 2022 Open Cap Table Coalition (https://opencaptablecoalition.com) /
# Original File: https://github.com/Open-Cap-Table-Coalition/Open-Cap-Format-OCF/t
# ree/v1.0.0/schema/primitives/objects/transactions/reissuance/Reissuance.schema.j
# son

from pydantic import BaseModel
from typing import Optional


class Reissuance(BaseModel):
    """Abstract object describing common properties to a reissuance of a security"""

    # Identifier of the new security (or securities) issuance resulting from a
    # reissuance
    resulting_security_ids: list[str]
    # When stock is reissued as a result of a stock split, this field contains id of
    # the respective stock class split transaction. It is not set otherwise.
    split_transaction_id: Optional[str]
    # Free-form human-readable reason for stock reissuance
    reason_text: Optional[str]
