"""Abstract object describing fields common to all release transaction objects"""

# Autogenerated, do not edit.
# Copyright © 2023 FMR LLC
#
# Based on the Open Captable Format schema:
# Copyright © 2022 Open Cap Table Coalition (https://opencaptablecoalition.com) /
# Original File: https://github.com/Open-Cap-Table-Coalition/Open-Cap-Format-OCF/t
# ree/v1.0.0/schema/primitives/objects/transactions/release/Release.schema.json

from pydantic import BaseModel
from pyocf.types.date import Date
from pyocf.types.monetary import Monetary
from pyocf.types.numeric import Numeric
from typing import Optional


class Release(BaseModel):
    """Abstract object describing fields common to all release transaction objects"""

    # The settlement date for the shares released, typically after the release
    # transaction date
    settlement_date: Date
    # The release price used to determine the value of the security at the time of
    # release
    release_price: Monetary
    # Quantity of shares released
    quantity: Numeric
    # Unstructured text description of consideration provided in exchange for security
    # release
    consideration_text: Optional[str]
    # Identifier of the new security (or securities) issuance resulting from a release
    # transaction
    resulting_security_ids: list[str]
