"""Type representation of an address"""

# Autogenerated, do not edit.
# Copyright © 2023 FMR LLC
#
# Based on the Open Captable Format schema:
# Copyright © 2022 Open Cap Table Coalition (https://opencaptablecoalition.com) /
# Original File: https://github.com/Open-Cap-Table-Coalition/Open-Cap-Format-
# OCF/tree/v1.0.0/schema/types/Address.schema.json

from pydantic import BaseModel
from pyocf.enums.addresstype import AddressType
from pyocf.types.countrycode import CountryCode
from pyocf.types.countrysubdivisioncode import CountrySubdivisionCode
from typing import Optional


class Address(BaseModel):
    """Type representation of an address"""

    # What type of address is this (e.g. legal address, contact address, etc.)
    address_type: AddressType
    # Street address (multi-line string)
    street_suite: Optional[str]
    # City
    city: Optional[str]
    # State, province, or equivalent identifier required for an address in this
    # country
    country_subdivision: Optional[CountrySubdivisionCode]
    # Country code for this address (ISO 3166-1 alpha-2)
    country: CountryCode
    # Address postal code
    postal_code: Optional[str]
