"""Type representation of an email address"""

# Autogenerated, do not edit.
# Copyright © 2023 FMR LLC
#
# Based on the Open Captable Format schema:
# Copyright © 2022 Open Cap Table Coalition (https://opencaptablecoalition.com) /
# Original File: https://github.com/Open-Cap-Table-Coalition/Open-Cap-Format-
# OCF/tree/v1.0.0/schema/types/Email.schema.json

from pydantic import BaseModel
from pyocf.enums.emailtype import EmailType


class Email(BaseModel):
    """Type representation of an email address"""

    # Type of e-mail address (e.g. personal or business)
    email_type: EmailType
    # A valid e-mail address
    email_address: str
