"""Type representation of a termination window"""

# Autogenerated, do not edit.
# Copyright © 2023 FMR LLC
#
# Based on the Open Captable Format schema:
# Copyright © 2022 Open Cap Table Coalition (https://opencaptablecoalition.com) /
# Original File: https://github.com/Open-Cap-Table-Coalition/Open-Cap-Format-
# OCF/tree/v1.0.0/schema/types/TerminationWindow.schema.json

from pydantic import BaseModel
from pyocf.enums.periodtype import PeriodType
from pyocf.enums.terminationwindowtype import TerminationWindowType


class TerminationWindow(BaseModel):
    """Type representation of a termination window"""

    # What cause of termination is this window for?
    reason: TerminationWindowType
    # The length of the period in this termination window (in number of periods of
    # type period_type)
    period: int
    # The type of period being measured (e.g. days or month)
    period_type: PeriodType
