"""Describes a period of time expressed in months (e.g. 3 months) for use in
Vesting Terms."""

# Autogenerated, do not edit.
# Copyright © 2023 FMR LLC
#
# Based on the Open Captable Format schema:
# Copyright © 2022 Open Cap Table Coalition (https://opencaptablecoalition.com) /
# Original File: https://github.com/Open-Cap-Table-Coalition/Open-Cap-Format-
# OCF/tree/v1.0.0/schema/types/vesting/VestingPeriodInMonths.schema.json

from pyocf.enums.vestingdayofmonth import VestingDayOfMonth
from pyocf.primitives.types.vesting.vestingperiod import VestingPeriod
from typing import Literal


class VestingPeriodInMonths(VestingPeriod):
    """Describes a period of time expressed in months (e.g. 3 months) for use in
    Vesting Terms.
    """

    # The quantity of `type` units of time; e.g. for 3 months, this would be `3`; for
    # 30 days, this would be `30`
    length: int
    type: Literal["MONTHS"] = "MONTHS"
    # The number of times this vesting period triggers. If vesting occurs monthly for
    # 36 months, for example, this would be `36`
    occurrences: int
    # The calendar day of a month to award vesting.
    day_of_month: VestingDayOfMonth
